'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.failRequest = exports.completeRequest = exports.acknowledgeRequest = exports.createQueryRequest = exports.createPostRequest = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _constants = require('../constants');

/** Initiate a request for a single entity from the WP-API. */
var createPostRequest = exports.createPostRequest = function createPostRequest(contentType, identifier) {
  return { type: _constants.ActionTypes.RequestCreatePost, contentType: contentType, identifier: identifier };
};

/** Initiate an arbitrary request to the WP-API. */
var createQueryRequest = exports.createQueryRequest = function createQueryRequest(queryFn, preserve) {
  return { type: _constants.ActionTypes.RequestCreateQuery, queryFn: queryFn, preserve: preserve };
};

/** Acknowledge a create* request by placing record of it on the store. */
var acknowledgeRequest = exports.acknowledgeRequest = function acknowledgeRequest(action) {
  return _extends({}, action, { type: _constants.ActionTypes.RequestAck });
};

/** Place the result of a successful request on the store */
var completeRequest = exports.completeRequest = function completeRequest(id, data) {
  return { type: _constants.ActionTypes.RequestComplete, id: id, data: data };
};

/** Update the record of a request with the error returned from a failed response. */
var failRequest = exports.failRequest = function failRequest(id, error) {
  return { type: _constants.ActionTypes.RequestFail, id: id, error: error };
};